/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Skeleton interface for Bison GLR parsers in C

   Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

#ifndef YY_YY_LEXER_THEME_PARSER_H_INCLUDED
# define YY_YY_LEXER_THEME_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 34 "../lexer/theme-parser.y"

#include "theme.h"
#include "xrmoptions.h"
#include "css-colors.h"
#include "rofi.h"

typedef struct YYLTYPE {
  int first_line;
  int first_column;
  int last_line;
  int last_column;
  char *filename;
} YYLTYPE;
# define YYLTYPE_IS_DECLARED 1 /* alert the parser that we have our own definition */

# define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                 \
      if (N)                                                           \
        {                                                              \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;       \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;     \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;        \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;      \
          (Current).filename     = YYRHSLOC (Rhs, 1).filename;         \
        }                                                              \
      else                                                             \
        { /* empty RHS */                                              \
          (Current).first_line   = (Current).last_line   =             \
            YYRHSLOC (Rhs, 0).last_line;                               \
          (Current).first_column = (Current).last_column =             \
            YYRHSLOC (Rhs, 0).last_column;                             \
          (Current).filename  = NULL;                        /* new */ \
        }                                                              \
    while (0)

#line 80 "lexer/theme-parser.h"

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    T_END = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_ERROR = 1,                   /* "error from file parser"  */
    T_ERROR_PROPERTY = 2,          /* "invalid property value"  */
    T_ERROR_SECTION = 3,           /* "invalid property name"  */
    T_ERROR_NAMESTRING = 4,        /* "invalid element name"  */
    T_ERROR_DEFAULTS = 5,          /* "invalid defaults name"  */
    T_ERROR_INCLUDE = 6,           /* "invalid import value"  */
    T_ERROR_ARGB_SPEC = 7,         /* "invalid argb color. Requires 8 (not 7) elements: argb:AARRGGBB."  */
    T_INT = 258,                   /* "Integer number"  */
    T_DOUBLE = 259,                /* "Floating-point number"  */
    T_STRING = 260,                /* "UTF-8 encode string"  */
    T_MEDIA_TYPE = 261,            /* "Media type"  */
    T_PROP_NAME = 262,             /* "property name"  */
    T_COLOR_NAME = 263,            /* "Color value by name"  */
    T_NAME_ELEMENT = 264,          /* "Element name"  */
    T_BOOLEAN = 265,               /* "Boolean value (true or false)"  */
    T_COLOR = 266,                 /* "Hexidecimal color value"  */
    T_LINK = 267,                  /* "Reference"  */
    T_ELEMENT = 268,               /* "Name of element"  */
    T_POS_CENTER = 269,            /* "Center"  */
    T_POS_EAST = 270,              /* "East"  */
    T_POS_WEST = 271,              /* "West"  */
    T_POS_NORTH = 272,             /* "North"  */
    T_POS_SOUTH = 273,             /* "South"  */
    T_MEDIA = 274,                 /* "@media"  */
    T_NONE = 275,                  /* "None"  */
    T_BOLD = 276,                  /* "Bold"  */
    T_ITALIC = 277,                /* "Italic"  */
    T_UNDERLINE = 278,             /* "Underline"  */
    T_STRIKETHROUGH = 279,         /* "Strikethrough"  */
    T_DASH = 280,                  /* "Dash"  */
    T_SOLID = 281,                 /* "Solid"  */
    T_UPPERCASE = 282,             /* "Uppercase"  */
    T_CAPITALIZE = 283,            /* "Capitalize"  */
    T_LOWERCASE = 284,             /* "Lowercase"  */
    T_UNIT_PX = 285,               /* "pixels"  */
    T_UNIT_MM = 286,               /* "mm"  */
    T_UNIT_EM = 287,               /* "em"  */
    T_UNIT_CH = 288,               /* "ch"  */
    T_ANGLE_DEG = 289,             /* "Degrees"  */
    T_ANGLE_GRAD = 290,            /* "Gradians"  */
    T_ANGLE_RAD = 291,             /* "Radians"  */
    T_ANGLE_TURN = 292,            /* "Turns"  */
    ORIENTATION_HORI = 293,        /* "Horizontal"  */
    ORIENTATION_VERT = 294,        /* "Vertical"  */
    CURSOR_DEF = 295,              /* "Default"  */
    CURSOR_PTR = 296,              /* "Pointer"  */
    CURSOR_TXT = 297,              /* "Text"  */
    T_COL_RGBA = 298,              /* "rgb[a] colorscheme"  */
    T_COL_HSL = 299,               /* "hsl colorscheme"  */
    T_COL_HWB = 300,               /* "hwb colorscheme"  */
    T_COL_CMYK = 301,              /* "cmyk colorscheme"  */
    T_URL = 302,                   /* "an URL"  */
    T_WIDTH = 303,                 /* "an WIDTH"  */
    T_HEIGHT = 304,                /* "an HEIGHT"  */
    T_BOTH = 305,                  /* "an BOTH"  */
    T_TO = 306,                    /* "an TO"  */
    T_LEFT = 307,                  /* "an LEFT"  */
    T_RIGHT = 308,                 /* "an RIGHT"  */
    T_TOP = 309,                   /* "an TOP"  */
    T_BOTTOM = 310,                /* "an BOTTOM"  */
    T_LINEAR_GRADIENT = 311,       /* "a linear gradient"  */
    T_PARENT_LEFT = 312,           /* "Parent left ('(')"  */
    T_PARENT_RIGHT = 313,          /* "Parent right (')')"  */
    T_COMMA = 314,                 /* "comma separator (',')"  */
    T_FORWARD_SLASH = 315,         /* "forward slash ('/')"  */
    T_PERCENT = 316,               /* "Percent sign ('%')"  */
    T_LIST_OPEN = 317,             /* "List open ('[')"  */
    T_LIST_CLOSE = 318,            /* "List close (']')"  */
    T_MODIFIER_ADD = 319,          /* "Add ('+')"  */
    T_MODIFIER_MULTIPLY = 320,     /* "Multiply ('*')"  */
    T_MODIFIER_MODULO = 321,       /* "Modulo ('modulo')"  */
    T_MODIFIER_MAX = 322,          /* "Max ('max')"  */
    T_MODIFIER_MIN = 323,          /* "Min ('min')"  */
    T_MODIFIER_ROUND = 324,        /* "Min ('round')"  */
    T_MODIFIER_FLOOR = 325,        /* "Min ('floor')"  */
    T_MODIFIER_CEIL = 326,         /* "Min ('ceil')"  */
    T_CALC = 327,                  /* "calc"  */
    T_BOPEN = 328,                 /* "bracket open ('{')"  */
    T_BCLOSE = 329,                /* "bracket close ('}')"  */
    T_PSEP = 330,                  /* "property separator (':')"  */
    T_PCLOSE = 331,                /* "property close (';')"  */
    T_NSEP = 332,                  /* "Name separator (' ' or '.')"  */
    T_SSEP = 333,                  /* "Selector separator (',')"  */
    T_NAME_PREFIX = 334,           /* "Element section ('# {name} { ... }')"  */
    T_PDEFAULTS = 335,             /* "Default settings section ( '* { ... }')"  */
    T_CONFIGURATION = 336,         /* "Configuration block"  */
    T_RESET_THEME = 337,           /* "Reset Theme"  */
    T_COLOR_TRANSPARENT = 338,     /* "Transparent"  */
    T_INHERIT = 339,               /* "Inherit"  */
    T_MIN = 340,                   /* "-"  */
    T_VAR_START = 341,             /* "var"  */
    T_ENV_START = 342              /* "env"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 139 "../lexer/theme-parser.y"

    int           ival;
    double        fval;
    char          *sval;
    char          cval;
    int           bval;
    WindowLocation wloc;
    ThemeColor    colorval;
    ThemeWidget   *theme;
    GList         *list;
    Property      *property;
    GHashTable    *property_list;
    RofiDistance      distance;
    RofiDistanceUnit  *distance_unit;

#line 207 "lexer/theme-parser.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int yyparse (const char *what);

#endif /* !YY_YY_LEXER_THEME_PARSER_H_INCLUDED  */
